<?php

namespace App\Entity;

use App\Repository\TablesRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: TablesRepository::class)]
class Tables
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    /**
     * @var Collection<int, Clients>
     */
    #[ORM\ManyToMany(targetEntity: Clients::class, mappedBy: 'Tabl')]
    private Collection $Tabl;

    /**
     * @var Collection<int, Reservations>
     */
    #[ORM\OneToMany(targetEntity: Reservations::class, mappedBy: 'Tabl')]
    private Collection $reservations;

    public function __construct()
    {
        $this->Tabl = new ArrayCollection();
        $this->reservations = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    /**
     * @return Collection<int, Clients>
     */
    public function getTabl(): Collection
    {
        return $this->Tabl;
    }

    public function addTabl(Clients $tabl): static
    {
        if (!$this->Tabl->contains($tabl)) {
            $this->Tabl->add($tabl);
            $tabl->addTabl($this);
        }

        return $this;
    }

    public function removeTabl(Clients $tabl): static
    {
        if ($this->Tabl->removeElement($tabl)) {
            $tabl->removeTabl($this);
        }

        return $this;
    }

    /**
     * @return Collection<int, Reservations>
     */
    public function getReservations(): Collection
    {
        return $this->reservations;
    }

    public function addReservation(Reservations $reservation): static
    {
        if (!$this->reservations->contains($reservation)) {
            $this->reservations->add($reservation);
            $reservation->setTabl($this);
        }

        return $this;
    }

    public function removeReservation(Reservations $reservation): static
    {
        if ($this->reservations->removeElement($reservation)) {
            // set the owning side to null (unless already changed)
            if ($reservation->getTabl() === $this) {
                $reservation->setTabl(null);
            }
        }

        return $this;
    }
}
